var tempWidget = {
    dataSource : 'http://fawn.ifas.ufl.edu/controller.php/widget/'
    ,critTemp : {
        defaultValue : null
        ,get : function () {
            val = parseInt($('#critTemp')[0].value);
            return isNaN(val)
                ? null
                : val;
        }
        // returns bool (was val a valid int?)
        ,set : function (val) {
            val = parseInt(val);
            if (isNaN(val)) {
                return false;
            } else {
                // update input
                var el = $('#critTemp')[0];
                if (val != el.value) {
                    el.value = val;
                }
                xwidget.set(val, 'critTemp');
                tempWidget.updateTemp();
                return true;
            }
        }
        ,onKeyUp : function () {
            // this = critTemp input
            // check for bad chars
            if (/^\s*-?\d+\s*$/.test(this.value)) {
                tempWidget.critTemp.set(this.value);
            }
        }
        ,onBlur : function () {
            // this = critTemp input
            if (tempWidget.critTemp.set(this.value)) {
                this.value = parseInt(this.value);
            } else {
                // NaN
                this.value = tempWidget.critTemp.defaultValue;
                tempWidget.updateTemp();
            }
        }
        ,onFocus : function () {
            // this = critTemp input
            if (this.value == tempWidget.critTemp.defaultValue)
                this.value = '';
            else {
                this.select();
            }
        }
    }
    ,updateTemp : function () {
        var t = tempWidget.station.temp
            ,klass = '';
        if (t == 'n/a') {
            $('#temp').text(t)[0].className = 'na';
        } else {
            $('#temp').text(t + '\u00b0')[0].className = (t < tempWidget.critTemp.get())
                ? 'belowCritTemp'
                : '';
        }
        $('#temp')[0].title = "Open FAWN page for " + tempWidget.station.name;
    }
    ,station : {
        name : null
        ,temp : 'n/a'
        ,set : function (name) {
            var el = $('#station')[0]
                ,opts = el.options;
            for (var i = 0, l = opts.length; i < l; ++i) {
                if ($(opts[i]).text() == name) {
                    el.selectedIndex = i;
                    break;
                }
            }
            tempWidget.station.name = name;
            tempWidget.station.temp = el.value;
            tempWidget.updateTemp();
        }
        ,onChange : function () {
            // this = select element
            tempWidget.station.temp = this.value;
            tempWidget.station.name = $(this.options[this.selectedIndex]).text();
            xwidget.set(tempWidget.station.name, 'station');
            tempWidget.updateTemp();
        }
        ,rebuild : function (list) {
            var currentName = tempWidget.station.name || xwidget.get('station');
            var ops = [];
            for (var name in list) {
                ops.push('<option value="' + list[name] + '">' + name + '</value>');
            }
            $('#station').html(ops.join(''));
            tempWidget.station.set(currentName);
        }
    }
    ,time : { // time is unixtime (s not ms)
        last : 0
        // returns bool (time changed)
        ,update : function (time) {
            if (time != tempWidget.time.last) {
                tempWidget.time.last = time;
                $('#info').html("updated @ " + new Date(time * 1000).formatDate('g:i A'))
                    .fadeIn(0)
                    .fadeTo(3000, 0.5);
                return true;
            }
            return false;
        }
    }
    ,loadData : function () {
        $.getJSON(tempWidget.dataSource + 'temps/', function (stations) {
            if (tempWidget.time.update(stations.time)) {
                // new data
                tempWidget.station.rebuild(stations.list);
                tempWidget.setupTempClick && tempWidget.setupTempClick();
            }
        });
    }
    ,timer : null
    ,begin : function () {
        tempWidget.critTemp.defaultValue = $('#critTemp').val();
        
        $('#station').change(tempWidget.station.onChange)
                     .keypress(tempWidget.station.onChange);
        $('#critTemp').keyup(tempWidget.critTemp.onKeyUp)
                      .blur(tempWidget.critTemp.onBlur)
                      .focus(tempWidget.critTemp.onFocus);
        // default prefs
        if (! xwidget.get('station')) {
            xwidget.set('Alachua', 'station');
        }
        tempWidget.critTemp.set(xwidget.get('critTemp'));
        tempWidget.wake();
    }
    ,sleep : function () {
        clearInterval(tempWidget.timer);
    }
    ,wake : function () {
        tempWidget.loadData();
        tempWidget.timer = setInterval(tempWidget.loadData, 3 * 60 * 1000); // 3 min
    }
    ,setupTempClick : function () {
        $('#temp').css({'cursor':'pointer'})
            .click(function () {
            xwidget.open(tempWidget.dataSource + 'tempsStation/' + escape(tempWidget.station.name));
        });
        tempWidget.setupTempClick = null; // run only once
    }
};

xwidget.setEvent('load', tempWidget.begin);
xwidget.setEvent('hide', tempWidget.sleep);
xwidget.setEvent('show', tempWidget.wake);

$(function () {
    function hidePrefs() {
        $('#back').flipTo('#front');
    }
    function showPrefs() {
        $('#front').flipTo('#back');
    }
    var gDoneButton, gInfoButton;
    
    gDoneButton = new AppleGlassButton($('#doneButton')[0], "Done", hidePrefs);
    gInfoButton = new AppleInfoButton($("#infoButton")[0], $('#front')[0], "white", "white", showPrefs);
});


