var xwidget = {
    // returns string or undefined
    get : function (key) {
        return widget.preferenceForKey(key);
    }
    // sets string version of pref to key (bools to ''/'1')
    // use pref = null to remove key
    ,set : function (pref, key) {
        widget.setPreferenceForKey(xwidget._stringize(pref), key);
    }
    ,clear : function (key) {
        xwidget.set(null, key);
    }
    ,open : function (url) {
        widget.openURL(url);
    }
    ,setEvent : function (name, func) {
        if (name == 'load')
            window.onload = func;
        else
            widget['on' + name] = func;
    }
    ,browser : false
    ,dashboard : false
    ,opera : false
    ,runSync : function () {}
    ,runAsync : function () {}
    ,_stringize : function (pref) {
        if (pref == null) 
            return null;
        if (pref.constructor == Boolean)
            return pref
                ? '1'
                : '';
        return pref.toString();
    }
};
if (window.widget) {
    if (widget.getAttention) 
        xwidget.opera = true;
    else
        xwidget.dashboard = true;
} else 
    xwidget.browser = true;

if (xwidget.browser) {
    xwidget._emptyString = '__empty_string__';
    xwidget.get = function (key) {
        var ret = xwidget._cookie('xwidget_' + key);
        return (ret == null)
            ? undefined
            : (ret == xwidget._emptyString
                ? ''
                : ret
            );
    };
    xwidget.set = function (pref, key) {
        if (pref != null) {
            if (pref.constructor == Boolean)
                pref = pref
                    ? '1'
                    : xwidget._emptyString;
            else
                pref = pref.toString();
        }
        xwidget._cookie('xwidget_' + key, pref);
    };
    xwidget.setEvent = function (name, func) {
        if (name == 'load')
            window.onload = func;
    };
    xwidget.open = function (url) {
        window.open(url);
    };
    xwidget._cookie = function(name, value, options) {
        if (typeof value != 'undefined') { // name and value given, set cookie
            options = options || {};
            if (value === null) {
                value = '';
                options.expires = -1;
            }
            var expires = '';
            if (options.expires && (typeof options.expires == 'number' || options.expires.toUTCString)) {
                var date;
                if (typeof options.expires == 'number') {
                    date = new Date();
                    date.setTime(date.getTime() + (options.expires * 24 * 60 * 60 * 1000));
                } else {
                    date = options.expires;
                }
                expires = '; expires=' + date.toUTCString(); // use expires attribute, max-age is not supported by IE
            }
            var path = options.path ? '; path=' + options.path : '';
            var domain = options.domain ? '; domain=' + options.domain : '';
            var secure = options.secure ? '; secure' : '';
            document.cookie = [name, '=', encodeURIComponent(value), expires, path, domain, secure].join('');
        } else { // only name given, get cookie
            if (document.cookie) {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = jQuery.trim(cookies[i]);
                    // Does this cookie string begin with the name we want?
                    if (cookie.substring(0, name.length + 1) == (name + '=')) {
                        return decodeURIComponent(cookie.substring(name.length + 1));
                    }
                }
            }
            return null;
        }
    };
}
if (xwidget.dashboard) {
    xwidget.runSync = function (command, callBack) { 
        s = widget.system(command, NULL); 
        callBack(s.outputString, s.errorString, s.status); 
    };
    xwidget.runAsync = function (command, callBack, stdout, stderr) {
        s = widget.system(command, callBack);
        s.onreadoutput = stdout;
        s.onreaderror  = stderr;
        return s;
    };
} else {
    xwidget._appleButtonCss = {
        'color':'#fff'
        ,'width':'.8em'
        ,'text-align':'center'
        ,'background':'#888'
        ,'font-style':'italic'
        ,'cursor':'pointer'
        ,'-moz-border-radius':'100%'
    };
    var AppleGlassButton = function (buttonEl, title, callback) {
        buttonEl.innerHTML = 'x';
        buttonEl.title = title;
        $(buttonEl).click(callback)
            .css(xwidget._appleButtonCss);
    };
    var AppleInfoButton = function (buttonEl, frontEl, foo, foo2, callback) {
        buttonEl.innerHTML = 'i';
        $(buttonEl).click(callback)
            .css(xwidget._appleButtonCss);
        $(frontEl).hover(
            function () { $(buttonEl).css({'background':'#aaa'}); }
            ,function () { $(buttonEl).css({'background':'#888'}); }
        );
    };
}

jQuery.fn.flipTo = function(expr) {
    xwidget.dashboard && widget.prepareForTransition("ToBack");
    this.hide();
    jQuery(expr).show();
    xwidget.dashboard && setTimeout("widget.performTransition()", 0);
};
